package org.university.core;

import java.util.*;

public abstract class AbstractEmployee extends Person{
    protected ArrayList<Statement> bankStatements;

    protected String position;

    protected Date lastPromote;

    protected double basicIncome;

    public AbstractEmployee(String name, int entranceYear, int id){
        super(name, entranceYear, id);
        bankStatements = new ArrayList<>();
        lastPromote = new Date();
    }

    public String getPosition(){
        return position;
    }

    public void addBankStatement(Statement s){
        bankStatements.add(s);
    }

    public Statement[] getBankStatements(){
        Statement[] arr = new Statement[bankStatements.size()];
        bankStatements.toArray(arr);
        return arr;
    }

    public void setBasicIncome(double income){
        this.basicIncome = income;
    }

    public boolean promote(){
        if(isPromotable()){
            lastPromote = new Date();
            return true;
        }
        return false;
    }

    abstract public double getCurrentIncome();

    abstract public boolean isPromotable();
}
